//Read preferences from file
//Adapted from Marq's PETSCII editor

final String machinenames[]={
          "C64",
          "C64M",
          "SPECTRUM",
          "MSX",
          "PLUS4",
          "PLUS4M",
          "CPC"
          };
final String ext_machinenames[]={
          "C64",
          "C64M",
          "SPECTRUM",
          "MSX",
          "PLUS4",
          "PLUS4M",
          "CPC",
          "QLLOW",
          "AMIGA",
          "C64NOLIMIT",
          "PICO8",
          "BK0010",
          "COCO3"
};
//a bit sad
final int g_machineidx[]={C64,C64M,SPECTRUM,MSX,PLUS4,PLUS4M,CPC,QLLOW,AMIGA,C64NOLIMIT,PICO8,BK0010,COCO3};

int g_inhibit_aspect=0;
int g_filelist=0;
int g_forcex=0;
int g_forcey=0;
int g_hadjust=0;
int g_vadjust=0;
int g_wheelup=':';
int g_wheeldown=';';
int g_middlebutton=',';

String g_forcedpalette="";

void pref_loader(){
      if(fexists(sketchPath("prefs.txt"))){
        readprefs(sketchPath("prefs.txt"));
        return;
      }
      if(fexists("prefs.txt")){
        readprefs("prefs.txt");
        return;
      }
}

void readprefs(String fname)
    {
        String row[]=loadStrings(fname);
        
        if(row==null)
            return;
            
        for(int i=0;i<row.length;i++) // Parse each line
        {
            if(row[i].length()>1)
            {
                String s[]=split(row[i],"=");
                
                if(s[0].equals("ZOOM"))
                {
                    g_uizoom=int(s[1]);
                    if(g_uizoom<1)g_uizoom=2;
                    if(g_uizoom>3)g_uizoom=2;
                }
                
                if(s[0].equals("FORCEX"))
                {
                    g_forcex=int(s[1]);
                }

                if(s[0].equals("FORCEY"))
                {
                    g_forcey=int(s[1]);
                }             
 
                if(s[0].equals("HADJUST"))
                {
                    g_hadjust=int(s[1]);
                } 
                 if(s[0].equals("VADJUST"))
                {
                    g_vadjust=int(s[1]);
                }                
                if(s[0].equals("MACHINE") && s.length>1)
                {
                    for(int j=0;j<ext_machinenames.length;j++)
                        if(s[1].equals(ext_machinenames[j]))
                            machine=g_machineidx[j];
                }
                
                if(s[0].equals("PATH") && s.length>1)
                {
                    path=s[1];
                }

                if(s[0].equals("FILELIST") && s.length>1)
                {
                    g_filelist=int(s[1]);
                }

                if(s[0].equals("PALETTE64") && s.length>1)
                {
                    g_forcedpalette=s[1];
                }
                
                if(s[0].equals("KEYMACRO") && s.length>1 && s.length<80)
                {
                    g_keymacro=s[1];
                }      
                
                if(s[0].equals("PNGSCALE"))
                {
                    g_omag=int(s[1]);
                    if(g_omag<1||g_omag>10)g_omag=1;
                }
                
                if(s[0].equals("PNGHBORDER"))
                {
                    g_bordh=int(s[1]);
                    if(g_bordh<1||g_bordh>256)g_bordh=64;
                }
                
                if(s[0].equals("PNGVBORDER"))
                {
                    g_bordv=int(s[1]);
                    if(g_bordv<1||g_bordv>256)g_bordv=32;
                }

                if(s[0].equals("NOASPECT"))
                {
                    g_inhibit_aspect=int(s[1]);
                }    
                
                if(s[0].equals("WHEELUP"))
                {
                    g_wheelup=int(s[1]);
                }
                if(s[0].equals("WHEELDOWN"))
                {
                    g_wheeldown=int(s[1]);
                } 
                if(s[0].equals("MIDDLEBUTTON"))
                {
                    g_middlebutton=int(s[1]);
                }                 
            }
        }
    }
